require 'oekaki'
include Math

W, H = 600, 300
V0, A, G = 10.0, 0.75, 5.0

v = lambda {|n| - A ** n * sqrt(2 * G * H)}

t = lambda do |n|
  if n.zero?
    sqrt(2 * H / G)
  else
    ar = [1]
    n.times {|i| ar << 2 * A ** (i + 1)}
    sqrt(2 * H / G) * ar.inject(:+)
  end
end

y = lambda do |n, t1|
  if n.zero?
    H - G * t1 ** 2 / 2
  else
    t2 = t1 - t.call(n - 1)
    - v.call(n) * t2 - G * t2 ** 2 / 2
  end
end

x = lambda {|t1| V0 * t1}

num = lambda do |tm|
  1000.times {|i| return i if tm <= t.call(i)}
end

i = 0

Oekaki.app width: W, height: H do
  draw do
    clear
  end
  
  id = timer(20) do
    tm = i / V0
    x1 = x.call(tm)
    y1 = H - y.call(num[tm], tm)
    color(65535, 0, 0)
    arc(false, x1, y1, 4, 4, 0, 64 * 360)
    timer_stop(id) if i >= W
    i += 1
  end
end


